/* FS.H
 * MSC8 (VC++ 1.5)
 * FS 2.9
 * 270195
 * Copyright (C) M. van Breemen, 1992-1995, All rights reserved.
 */

#include <stddef.h>
#include <stdarg.h>

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include <io.h>
#include <sys\types.h>
#include <sys\utime.h>
#include <sys\stat.h>
#include <graph.h>
#include <string.h>
#include <direct.h>
#include <errno.h>
#include <time.h>
#include <bios.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <malloc.h>
#include <process.h>
#include <search.h>

#define MAX_FILES 912 /* default 8 screens, 6 columns of 19 files */
#define MAX_LINEWIDTH 160 /* default max. linewidth for S function */
	   
#define PAGES_PER_MEMBLOCK 250
#define LINES_PER_PAGE 20
	/* show_file */
			  
#define SUCCESS      0
#define EXIT_RESTORE 1
#define EXIT_KEEP    2
#define FAILURE     -1
#define ERROR       -1
#define NOCHANGE     1
#define TRUE         1
#define FALSE        0
#define INVALID     -1
#define ABORT       -1

#define K_F1        59+256
#define K_F2        60+256
#define K_F3        61+256
#define K_F4        62+256
#define K_F5        63+256
#define K_F6        64+256
#define K_F7        65+256
#define K_F8        66+256
#define K_F9        67+256
#define K_F10       68+256
#define K_PGUP      73+256
#define K_PGDN      81+256
#define K_INS       82+256
#define K_DEL       83+256
#define K_CUP       72+256
#define K_CDN       80+256
#define K_CLE       75+256
#define K_CRI       77+256
#define K_HOME      71+256
#define K_END       79+256
#define ESC         27
#define BS          8
#define FORMFEED    12
#define CR          13

#define SCAN_A      256+0x1E
#define SCAN_B      256+0x30
#define SCAN_C      256+0x2E
#define SCAN_D      256+0x20
#define SCAN_E      256+0x12
#define SCAN_F      256+0x21
#define SCAN_G      256+0x22
#define SCAN_H      256+0x23
#define SCAN_I      256+0x17
#define SCAN_J      256+0x24
#define SCAN_K      256+0x25
#define SCAN_L      256+0x26
#define SCAN_M      256+0x32
#define SCAN_N      256+0x31
#define SCAN_O      256+0x18
#define SCAN_P      256+0x19
#define SCAN_Q      256+0x10
#define SCAN_R      256+0x13
#define SCAN_S      256+0x1F
#define SCAN_T      256+0x14
#define SCAN_U      256+0x16
#define SCAN_V      256+0x2F
#define SCAN_W      256+0x11
#define SCAN_X      256+0x2D
#define SCAN_Y      256+0x15
#define SCAN_Z      256+0x2C


#define M_BLACK_BG    0
#define M_GRAY        2
#define M_GRAY_UNDL   1
#define M_GRAY_BG     7
#define M_WHITE       10
#define M_WHITE_UNDL  9

#define COLOR   3
#define MONO    7

#define BLACK   0
#define BLUE    1
#define GREEN   2
#define CYAN    3
#define RED     4
#define MAGENTA 5
#define BROWN   6
#define WHITE   7
#define DARKGRAY   8
#define LIGHTBLUE  9
#define LIGHTGREEN 10
#define LIGHTCYAN  11
#define LIGHTRED   12
#define LIGHTMAGENTA 13
#define YELLOW  14
#define BRIGHTWHITE 15

#define NOREPAINT   0
#define CURSOR      1
#define NORMAL      2

#define NOERROR     0
#define NOVOL       2
#define NOCREAT     3
#define NOREN       4
#define NODEL       5

/* Macro to peek at a specified memory address */
#define peek( addr )        (*(unsigned char _far *)addr)

#define NONE    0
#define NAME    1
#define DATE    2
#define SIZE    3

#define ASCENDING   0
#define DESCENDING  1

#define LEGAL       0
#define ILLEGAL     1
	/* editstr */
	
#define SINCE   0
#define BEFORE  1 
#define ALL     2
	/* turnover_datetime_mode */
